<?php

namespace Vidgyor\Playlist\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Vidgyor\Playlist\Interfaces\PlaylistRepositoryInterface;

class PlaylistPublicController extends BaseController
{
    // use PlaylistWorkflow;

    /**
     * Constructor.
     *
     * @param type \Vidgyor\Playlist\Interfaces\PlaylistRepositoryInterface $playlist
     *
     * @return type
     */
    public function __construct(PlaylistRepositoryInterface $playlist)
    {
        $this->repository = $playlist;
        parent::__construct();
    }

    /**
     * Show playlist's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $playlists = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();


        return $this->response->setMetaTitle(trans('$playlist::playlist.names'))
            ->view('playlist::playlist.index')
            ->data(compact('playlists'))
            ->output();
    }


    /**
     * Show playlist.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $playlist = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->response->setMetaTitle($$playlist->name . trans('playlist::playlist.name'))
            ->view('playlist::playlist.show')
            ->data(compact('playlist'))
            ->output();
    }

}
